From c0674ccbabb55c44d799a201f4e62ea0efd973e9 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 30 2020 06:47:17 +0000
Subject: [PATCH 1629/2232] Add string comparison tests


---

diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 340dc9c..934e58e 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -6,6 +6,7 @@
 #include <numeric>
 #include <stdexcept>
 #include <string>
+#include <tuple>
 
 extern "C" void cxx_test_suite_set_correct() noexcept;
 extern "C" tests::R *cxx_test_suite_get_box() noexcept;
@@ -656,6 +657,24 @@ extern "C" const char *cxx_run_test() noexcept {
   ASSERT(Shared{1} == Shared{1});
   ASSERT(Shared{1} != Shared{2});
 
+  rust::String first = "first", second = "second", sec = "sec";
+  bool (rust::String::*cmp)(const rust::String &) const;
+  bool first_first, first_second, sec_second, second_sec;
+  for (auto test : (std::tuple<decltype(cmp), bool, bool, bool, bool>[]) {
+    {&rust::String::operator==, true, false, false, false},
+    {&rust::String::operator!=, false, true, true, true},
+    {&rust::String::operator<, false, true, true, false},
+    {&rust::String::operator<=, true, true, true, false},
+    {&rust::String::operator>, false, false, false, true},
+    {&rust::String::operator>=, true, false, false, true},
+  }) {
+    std::tie(cmp, first_first, first_second, sec_second, second_sec) = test;
+    ASSERT((first.*cmp)(first) == first_first);
+    ASSERT((first.*cmp)(second) == first_second);
+    ASSERT((sec.*cmp)(second) == sec_second);
+    ASSERT((second.*cmp)(sec) == second_sec);
+  }
+
   cxx_test_suite_set_correct();
   return nullptr;
 }

